Package net.dona.doip.client

# Interface DoipClientInterface

All Superinterfaces:
  `AutoCloseable`

All Known Implementing Classes:
  `AbstractDoipClient`, `DoipClient`

public interface DoipClientInterface extends AutoCloseable

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  `DigitalObject`
  `create(DigitalObject dobj, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `DigitalObject`
  `create(DigitalObject dobj, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes)`
  `void`
  `delete(String targetId, AuthenticationInfo authInfo)`
  `void`
  `delete(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `void`
  `delete(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes)`
  `static DoipException`
  `doipExceptionFromDoipResponse(DoipClientResponse resp)`
  `DigitalObject`
  `hello(String targetId, AuthenticationInfo authInfo)`
  `DigitalObject`
  `hello(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `List<String>`
  `listOperations(String targetId, AuthenticationInfo authInfo)`
  `List<String>`
  `listOperations(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `List<String>`
  `listOperations(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes)`
  `DoipClientResponse`
  `performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes)`
  `DoipClientResponse`
  `performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, com.google.gson.JsonElement input)`
  `DoipClientResponse`
  `performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, com.google.gson.JsonElement input, ServiceInfo serviceInfo)`
  `DoipClientResponse`
  `performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, ServiceInfo serviceInfo)`
  `DoipClientResponse`
  `performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, InDoipMessage input)`
  `DoipClientResponse`
  `performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, InDoipMessage input, ServiceInfo serviceInfo)`
  `DoipClientResponse`
  `performOperation(DoipRequestHeaders headers, InDoipMessage input)`
  `DoipClientResponse`
  `performOperation(DoipRequestHeaders headers, InDoipMessage input, ServiceInfo serviceInfo)`
  `com.google.gson.JsonElement`
  `performOperationWithJsonResponse(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes)`
  `com.google.gson.JsonElement`
  `performOperationWithJsonResponse(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, com.google.gson.JsonElement input, ServiceInfo serviceInfo)`
  `com.google.gson.JsonElement`
  `performOperationWithJsonResponse(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, ServiceInfo serviceInfo)`
  `DigitalObject`
  `retrieve(String targetId, boolean includeElementData, AuthenticationInfo authInfo)`
  `DigitalObject`
  `retrieve(String targetId, boolean includeElementData, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `DigitalObject`
  `retrieve(String targetId, com.google.gson.JsonObject attributes, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `DigitalObject`
  `retrieve(String targetId, AuthenticationInfo authInfo)`
  `DigitalObject`
  `retrieve(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `InputStream`
  `retrieveElement(String targetId, String elementId, AuthenticationInfo authInfo)`
  `InputStream`
  `retrieveElement(String targetId, String elementId, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `InputStream`
  `retrieveElement(String targetId, String elementId, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes)`
  `InputStream`
  `retrievePartialElement(String targetId, String elementId, Long start, Long end, AuthenticationInfo authInfo)`
  `InputStream`
  `retrievePartialElement(String targetId, String elementId, Long start, Long end, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `InputStream`
  `retrievePartialElement(String targetId, String elementId, Long start, Long end, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes)`
  `SearchResults<DigitalObject>`
  `search(String targetId, String query, QueryParams params, AuthenticationInfo authInfo)`
  `SearchResults<DigitalObject>`
  `search(String targetId, String query, QueryParams params, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `SearchResults<String>`
  `searchIds(String targetId, String query, QueryParams params, AuthenticationInfo authInfo)`
  `SearchResults<String>`
  `searchIds(String targetId, String query, QueryParams params, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `DigitalObject`
  `update(DigitalObject dobj, AuthenticationInfo authInfo)`
  `DigitalObject`
  `update(DigitalObject dobj, AuthenticationInfo authInfo, ServiceInfo serviceInfo)`
  `DigitalObject`
  `update(DigitalObject dobj, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes)`

- ## Method Details

  - ### doipExceptionFromDoipResponse

    static DoipException doipExceptionFromDoipResponse(DoipClientResponse resp) throws IOException
    Throws:
      `IOException`

  - ### close

    void close()
    Specified by:
      `close` in interface `AutoCloseable`

  - ### performOperationWithJsonResponse

    com.google.gson.JsonElement performOperationWithJsonResponse(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes) throws DoipException
    Throws:
      `DoipException`

  - ### performOperationWithJsonResponse

    com.google.gson.JsonElement performOperationWithJsonResponse(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### performOperationWithJsonResponse

    com.google.gson.JsonElement performOperationWithJsonResponse(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, com.google.gson.JsonElement input, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### performOperation

    DoipClientResponse performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes) throws DoipException
    Throws:
      `DoipException`

  - ### performOperation

    DoipClientResponse performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, com.google.gson.JsonElement input) throws DoipException
    Throws:
      `DoipException`

  - ### performOperation

    DoipClientResponse performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, InDoipMessage input) throws DoipException
    Throws:
      `DoipException`

  - ### performOperation

    DoipClientResponse performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### performOperation

    DoipClientResponse performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, com.google.gson.JsonElement input, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### performOperation

    DoipClientResponse performOperation(String targetId, String operationId, AuthenticationInfo authInfo, com.google.gson.JsonObject attributes, InDoipMessage input, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### performOperation

    DoipClientResponse performOperation(DoipRequestHeaders headers, InDoipMessage input) throws DoipException
    Throws:
      `DoipException`

  - ### performOperation

    DoipClientResponse performOperation(DoipRequestHeaders headers, InDoipMessage input, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### create

    DigitalObject create(DigitalObject dobj, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### create

    DigitalObject create(DigitalObject dobj, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes) throws DoipException
    Throws:
      `DoipException`

  - ### update

    DigitalObject update(DigitalObject dobj, AuthenticationInfo authInfo) throws DoipException
    Throws:
      `DoipException`

  - ### update

    DigitalObject update(DigitalObject dobj, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### update

    DigitalObject update(DigitalObject dobj, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes) throws DoipException
    Throws:
      `DoipException`

  - ### retrieve

    DigitalObject retrieve(String targetId, AuthenticationInfo authInfo) throws DoipException
    Throws:
      `DoipException`

  - ### retrieve

    DigitalObject retrieve(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### retrieve

    DigitalObject retrieve(String targetId, boolean includeElementData, AuthenticationInfo authInfo) throws DoipException
    Throws:
      `DoipException`

  - ### retrieve

    DigitalObject retrieve(String targetId, boolean includeElementData, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### retrieve

    DigitalObject retrieve(String targetId, com.google.gson.JsonObject attributes, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### delete

    void delete(String targetId, AuthenticationInfo authInfo) throws DoipException
    Throws:
      `DoipException`

  - ### delete

    void delete(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### delete

    void delete(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes) throws DoipException
    Throws:
      `DoipException`

  - ### listOperations

    List<String> listOperations(String targetId, AuthenticationInfo authInfo) throws DoipException
    Throws:
      `DoipException`

  - ### listOperations

    List<String> listOperations(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### listOperations

    List<String> listOperations(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes) throws DoipException
    Throws:
      `DoipException`

  - ### searchIds

    SearchResults<String> searchIds(String targetId, String query, QueryParams params, AuthenticationInfo authInfo) throws DoipException
    Throws:
      `DoipException`

  - ### searchIds

    SearchResults<String> searchIds(String targetId, String query, QueryParams params, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### search

    SearchResults<DigitalObject> search(String targetId, String query, QueryParams params, AuthenticationInfo authInfo) throws DoipException
    Throws:
      `DoipException`

  - ### search

    SearchResults<DigitalObject> search(String targetId, String query, QueryParams params, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### hello

    DigitalObject hello(String targetId, AuthenticationInfo authInfo) throws DoipException
    Throws:
      `DoipException`

  - ### hello

    DigitalObject hello(String targetId, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### retrieveElement

    InputStream retrieveElement(String targetId, String elementId, AuthenticationInfo authInfo) throws DoipException
    Throws:
      `DoipException`

  - ### retrieveElement

    InputStream retrieveElement(String targetId, String elementId, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### retrieveElement

    InputStream retrieveElement(String targetId, String elementId, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes) throws DoipException
    Throws:
      `DoipException`

  - ### retrievePartialElement

    InputStream retrievePartialElement(String targetId, String elementId, Long start, Long end, AuthenticationInfo authInfo) throws DoipException
    Throws:
      `DoipException`

  - ### retrievePartialElement

    InputStream retrievePartialElement(String targetId, String elementId, Long start, Long end, AuthenticationInfo authInfo, ServiceInfo serviceInfo) throws DoipException
    Throws:
      `DoipException`

  - ### retrievePartialElement

    InputStream retrievePartialElement(String targetId, String elementId, Long start, Long end, AuthenticationInfo authInfo, ServiceInfo serviceInfo, com.google.gson.JsonObject attributes) throws DoipException
    Throws:
      `DoipException`